package rtflow;

public class RTflowCode {
%IF_HAS_BOOL%   /** The array of all boolean signals. */
%IF_HAS_BOOL%   private boolean[] %BOOL_VECTOR% = new boolean[%NUMBER_BOOL%];

%IF_HAS_INT%   /** The array of all integer signals. */
%IF_HAS_INT%   private int[] %INT_VECTOR% = new int[%NUMBER_INT%];

%IF_HAS_REAL%   /** The array of all real-valued signals. */
%IF_HAS_REAL%   private float[] %REAL_VECTOR% = new float[%NUMBER_REAL%];

%IF_HAS_BOOL%   /** The RTflow model names of all boolean signals. */
%IF_HAS_BOOL%   public String[] boolNames = new String[] {
%IF_HAS_BOOL%      "%BOOL_NAMES%",
%IF_HAS_BOOL%   };

%IF_HAS_INT%   /** The RTflow model names of all integer signals. */
%IF_HAS_INT%   public String[] intNames = new String[] {
%IF_HAS_INT%      "%INT_NAMES%",
%IF_HAS_INT%   };

%IF_HAS_REAL%   /** The RTflow model names of all real-valued signals. */
%IF_HAS_REAL%   public String[] realNames = new String[] {
%IF_HAS_REAL%      "%REAL_NAMES%",
%IF_HAS_REAL%   };

%IF_HAS_BOOL%   /** @return The array of all boolean signals. */
%IF_HAS_BOOL%   public boolean[] getBoolArray() { return %BOOL_VECTOR%; }

%IF_HAS_INT%   /** @return The array of all integer signals. */
%IF_HAS_INT%   public int[] getIntArray() { return %INT_VECTOR%; }

%IF_HAS_REAL%   /** @return The array of all real-valued signals. */
%IF_HAS_REAL%   public float[] getRealArray() { return %REAL_VECTOR%; }

   /**
    * @return The real time in seconds corresponding to one execution cycle.
    */
   public float getSampleTime() {
      return %SAMPLE_TIME%;
   }

   /**
    * Initializes the state of the system. Call this method once before
    * calling run().
    */
   public void initialize() {
      %INITIAL_EQUATIONS%
   }

   /**
    * Executes one cycle. Every cycle, the calling code should:
    * 1) Provide the input signal values by writing into the arrays.
    * 2) Call the run() method.
    * 3) Collect the output signal values by reading from the arrays.
    */
   public void run() {
      // Output update equations
      %OUTPUT_UPDATE_EQUATIONS%

      // State update equations
      %STATE_UPDATE_EQUATIONS%
   }
	
   /**
    * Finds the index of a signal given its name. The calling code can
    * use this function to retrieve the index to be used when reading
    * or writing in an array for a specific signal.
    * @param names The array of names to search; either boolNames, intNames or realNames.
    * @param name  The name of the signal to find the index for.
    * @return The index of the requested signal, or -1 if not found.
    */
   public static int findName(String[] names, String name) {
      for (int i = 0; i < names.length; i++) {
         if (names[i].equals(name)) {
            return i;
         }
      }
      return -1;
   }	
}
